from builtin.const import *
from builtin.proto import *
from builtin.stype import *


class SituationResult:
    class friends:
        grade: int = 0
        count: int = 0
        vector: PartsVector = None

    class enemies:
        grade: int = 0
        count: int = 0
        vector: PartsVector = None


class std:
    """
    标准库基础函数
    """

    @staticmethod
    def _expand_composite_as_list(filter_composite: tuple | list | set | callable) -> list:
        """
        展开函数容器表达式为list | Expand the function container expression to list
        :param filter_composite: 函数容器表达式 | function container expression
        :return: 展开后的list | expanded list
        """
        pass

    @staticmethod
    def _generate_combo_js_eval(filter_composite: tuple | list | set | callable, fid: dict) -> str:
        """
        生成js表达串 | Generate js expression string
        :param filter_composite: 函数容器表达式 | function container expression
        :param fid: 函数到id的映射 | function to id mapping
        :return: js表达串 | js expression string
        """
        pass

    @staticmethod
    def combo(filter_composite: tuple | list | set | callable) -> callable:
        """
        展开函数容器表达式 | Expand the function container expression

        函数容器表达式是一个由list(表示或)，tuple(表示与), set(表示not)组成的表达式，支持嵌套 |
            The function container expression is an expression composed of list (representing or), tuple (representing and), and set (representing not), supporting nesting

        * 你可以直接使用combo来代替std.combo | You can use combo directly instead of std.combo

        Args:
            filter_composite: 只由tuple、list和set组成的过滤器结构(最小单元是callable) |
                A filter structure consisting only of tuple, list, and set (the smallest unit is callable)

        Returns:
            一个新的可以表达输入表达式的函数 | A new function that can express the input expression
        """
        pass

    @staticmethod
    def log(caller_name: str, *args: str):
        """
        [caller_name Log]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def info(caller_name: str, *args: str):
        """
        [caller_name Info]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def warn(caller_name: str, *args: str):
        """
        [caller_name Warn]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def error(caller_name: str, *args: str):
        """
        [caller_name Error]: *args

        * 会抛出一个js的Error | Will throw a js Error

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def ansi_color(r, g=None, b=None, bg=False):
        """
        生成 ANSI 颜色代码字符串

        参数：
        r (str or int): 十六进制颜色字符串（如 '#ffffff'）或 RGB 值中的红色分量
        g (int, optional): RGB 值中的绿色分量，默认为 None. 如果 r 是十六进制颜色字符串，则 g 此时释义为bg
        b (int, optional): RGB 值中的蓝色分量，默认为 None
        bg (bool, optional): 是否为背景颜色，默认为 False

        返回值：
        str: ANSI 颜色代码字符串
        """
        pass

    @staticmethod
    def wrap_bracket(string, bracket, color) -> str:
        """
        在字符串两端添加指定的括号和颜色

        参数：
        string (str): 要添加括号的字符串
        bracket (str): 括号类型，例如 '(', '[', '{', '<', '"', "'" 中的一种
        color (str): 颜色代码，例如 '\x1b[32m' 表示绿色

        返回值：
        str: 添加括号和颜色后的字符串
        """
        pass

    @staticmethod
    def print_map(rect: Rect):
        """
        打印地图

        Args:
            rect: Rect 地图的范围
        """
        pass

    @staticmethod
    def broadcast(arr2d: list[list[int]], func: callable, start: st.point = Point(0, 0), end: st.point = None) -> list[
        list[int]]:
        """
        允许对一个2d数组中指定区域的元素进行逐个操作，并将返回值存储在原数组中。

        Args:
            arr2d: list[list[int]] 一个二维数组
            func: callable  对元素进行操作的函数
            start: st.point  开始坐标
            end: st.point  结束坐标

        Returns:
            list[list[int]] 返回一个二维数组
        """
        pass

    @staticmethod
    def show_welcome():
        pass

    @staticmethod
    def show_usage():
        pass


# get (game information)
class get:
    COST_MATRIX: CostMatrix = None
    COST_ARRAY2D: list[list[int]] = None
    P2: list[list[int]] = None
    P4: list[list[int]] = None
    P5: list[list[int]] = None
    P8: list[list[int]] = None
    P10: list[list[int]] = None

    # ------------------------------
    def ticks(self) -> int:
        """
        获取当前tick数

        Returns:
            int
        """
        pass

    def cpu(self) -> int:
        """
        获取当前tick已使用的cpu时间, 单位: 呐秒

        Returns:
            int
        """
        pass

    def heap(self) -> object:
        """
        获取heapInfo对象

        Returns:
            object，详见官方文档
        """
        pass

    def byid(self, id: str) -> GameObject:
        """
        通过id获取对象

        Args:
            id: str (X) 对象id

        Returns:
            object 如果没有找到，返回None
        """
        pass

    @staticmethod
    def cpu_us() -> int:
        """
        获取当前tick已使用的cpu时间, 单位: 微秒

        Returns:
            int
        """
        pass

    @staticmethod
    def arena() -> UsrObject:
        """
        获取arenaInfo对象

        Returns:
            object，包含以下属性:
                name:str The name of the arena.
                level:int Currently equals to 1 for basic arena and 2 for advanced.
                season:str Currently equals to "alpha".
                ticksLimit:int Game ticks limit.
                cpuTimeLimit:int CPU wall time execution limit per one tick (except the first tick).
                cpuTimeLimitFirstTick:int CPU wall time limit on the first tick.
        """
        pass

    @staticmethod
    def path(obj: st.point, target: st.point, options: UsrObject = None) -> list[st.point]:
        """
        返回obj到目标的路径

        Args:
            obj: st.point (X) 一个坐标点
            target: st.point (X) 一个坐标点
            options: UsrObject (X) 路径查找的选项

        Returns:
            list[st.point] 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def find(objs: list | tuple, filter_fn: list | tuple | set | callable) -> object:
        """
        Find the first object that satisfies the condition

        Args:
            objs: list | tuple (X) 待查找的对象列表
            filter_fn: list | tuple | set | callable (X) 容器函数表达式

        Returns:
            object
        """
        pass

    @staticmethod
    def filter(objs: list | tuple, filter_fn: list | tuple | set | callable) -> list:
        """
        Returns a list of objects that satisfy the condition

        Args:
            objs: list | tuple (X) 待查找的对象列表
            filter_fn: list | tuple | set | callable (X) 容器函数表达式

        Returns:
            list
        """
        pass

    @staticmethod
    def terrain(x_or_point: int | st.point, y: None | int = None) -> int:
        """
        获取指定位置的地形

        Args:
            x_or_point: int| st.point (X) x坐标或者坐标点
            y: None|int (X) y坐标。 如果传入了y坐标，那么期望的第一个参数x为int类型

        Returns:
            int 地形常量
        """
        pass

    @staticmethod
    def all(p_type: type, filter_fn: list | tuple | set | callable | None = None) -> list:
        """
        获取所有指定类型、指定条件的所有对象

        Args:
            p_type: type (X) 对象的类型
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def one(p_type: type, filter_fn: list | tuple | set | callable | None = None) -> object | None:
        """
        获取所有指定类型、指定条件的一个对象

        Args:
            p_type: type (X) 对象的类型
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            object | None 如果没有找到，返回None
        """
        pass

    @staticmethod
    def creeps(filter_fn: list | tuple | set | callable | None = None) -> list[Creep]:
        """
        获取所有满足条件的Creep

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def creep(filter_fn: list | tuple | set | callable | None = None) -> Creep | None:
        """
        获取一个满足条件的Creep

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Creep 如果没有找到，返回None
        """
        pass

    @staticmethod
    def friends(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的友方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def friend(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的友方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None

        Examples:
            ```python
            # 获取SpawnSwamp模式下的基地Spawn
            spawn = get.friend(st.spawn)
            # 方式2
            spawn = get.spawn(st.friend)
            ```
        """
        pass

    @staticmethod
    def enemies(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的敌方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def enemy(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的敌方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None
        """
        pass

    @staticmethod
    def spawns(filter_fn: list | tuple | set | callable | None = None) -> list[StructureSpawn]:
        """
        获取所有满足条件的Spawn

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def spawn(filter_fn: list | tuple | set | callable | None = None) -> StructureSpawn | None:
        """
        获取一个满足条件的Spawn

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureSpawn 如果没有找到，返回None
        """
        pass

    @staticmethod
    def structures(filter_fn: list | tuple | set | callable | None = None) -> list[Structure]:
        """
        获取所有满足条件的Structure

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def structure(filter_fn: list | tuple | set | callable | None = None) -> Structure | None:
        """
        获取一个满足条件的Structure

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Structure 如果没有找到，返回None
        """
        pass

    @staticmethod
    def sources(filter_fn: list | tuple | set | callable | None = None) -> list[Source]:
        """
        获取所有满足条件的Source

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def source(filter_fn: list | tuple | set | callable | None = None) -> Source | None:
        """
        获取一个满足条件的Source

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Source 如果没有找到，返回None
        """
        pass

    @staticmethod
    def sites(filter_fn: list | tuple | set | callable | None = None) -> list[ConstructionSite]:
        """
        获取所有满足条件的ConstructionSite

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def site(filter_fn: list | tuple | set | callable | None = None) -> ConstructionSite | None:
        """
        获取一个满足条件的ConstructionSite

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            ConstructionSite 如果没有找到，返回None
        """
        pass

    @staticmethod
    def resources(filter_fn: list | tuple | set | callable | None = None) -> list[Resource]:
        """
        获取所有满足条件的Resource

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def resource(filter_fn: list | tuple | set | callable | None = None) -> Resource | None:
        """
        获取一个满足条件的Resource

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Resource 如果没有找到，返回None
        """
        pass

    @staticmethod
    def towers(filter_fn: list | tuple | set | callable | None = None) -> list[StructureTower]:
        """
        获取所有满足条件的Tower

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def tower(filter_fn: list | tuple | set | callable | None = None) -> StructureTower | None:
        """
        获取一个满足条件的Tower

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureTower 如果没有找到，返回None
        """
        pass

    @staticmethod
    def walls(filter_fn: list | tuple | set | callable | None = None) -> list[StructureWall]:
        """
        获取所有满足条件的Wall

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def wall(filter_fn: list | tuple | set | callable | None = None) -> StructureWall | None:
        """
        获取一个满足条件的Wall

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureWall 如果没有找到，返回None
        """
        pass

    @staticmethod
    def ramparts(filter_fn: list | tuple | set | callable | None = None) -> list[StructureRampart]:
        """
        获取所有满足条件的Rampart

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def rampart(filter_fn: list | tuple | set | callable | None = None) -> StructureRampart | None:
        """
        获取一个满足条件的Rampart

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureRampart 如果没有找到，返回None
        """
        pass

    @staticmethod
    def extensions(filter_fn: list | tuple | set | callable | None = None) -> list[StructureExtension]:
        """
        获取所有满足条件的Extension

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def extension(filter_fn: list | tuple | set | callable | None = None) -> StructureExtension | None:
        """
        获取一个满足条件的Extension

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureExtension 如果没有找到，返回None
        """
        pass

    @staticmethod
    def boxes(filter_fn: list | tuple | set | callable | None = None) -> list[StructureContainer]:
        """
        获取所有满足条件的Container

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def box(filter_fn: list | tuple | set | callable | None = None) -> StructureContainer | None:
        """
        获取一个满足条件的Container

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureContainer 如果没有找到，返回None
        """
        pass

    @staticmethod
    def roads(filter_fn: list | tuple | set | callable | None = None) -> list[StructureRoad]:
        """
        获取所有满足条件的Road

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def road(filter_fn: list | tuple | set | callable | None = None) -> StructureRoad | None:
        """
        获取一个满足条件的Road

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureRoad 如果没有找到，返回None
        """
        pass

    @staticmethod
    def flags(filter_fn: list | tuple | set | callable | None = None) -> list[Flag]:
        """
        获取所有满足条件的Flag

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def flag(filter_fn: list | tuple | set | callable | None = None) -> Flag | None:
        """
        获取一个满足条件的Flag

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Flag 如果没有找到，返回None
        """
        pass

    @staticmethod
    def bodyParts() -> list[BodyPart]:
        """
        获取当前房间内所有Creep的body部件

        Returns:
            list[str]
        """
        pass

    @staticmethod
    def bodyPart(part: str) -> BodyPart:
        """
        获取指定部件的详细信息

        Args:
            part: str (X) 部件名称

        Returns:
            BodyPart
        """
        pass

    @staticmethod
    def gobjects(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的GameObject

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def gobject(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的GameObject

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None
        """
        pass

    @staticmethod
    def scoreCollectors(filter_fn: list | tuple | set | callable | None = None) -> list[ScoreCollector]:
        """
        获取所有满足条件的ScoreCollector

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def scoreCollector(filter_fn: list | tuple | set | callable | None = None) -> ScoreCollector | None:
        """
        获取一个满足条件的ScoreCollector

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            ScoreCollector 如果没有找到，返回None
        """
        pass

    @staticmethod
    def areaEffects(filter_fn: list | tuple | set | callable | None = None) -> list[AreaEffect]:
        """
        获取所有满足条件的AreaEffect

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def areaEffect(filter_fn: list | tuple | set | callable | None = None) -> AreaEffect | None:
        """
        获取一个满足条件的AreaEffect

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            AreaEffect 如果没有找到，返回None
        """
        pass

    @staticmethod
    def energy(target: st.storable, percent: bool = False) -> int | float:
        """
        获取目标的能量值

        Args:
            target: st.storable (X) 一个可存储资源的游戏对象
            percent: bool (X) 是否返回百分比

        Returns:
            int | float 如果percent为True，返回百分比float，否则返回具体能量值int

        """
        pass

    @staticmethod
    def score(target: st.storable, percent: bool = False) -> int | float:
        """
        获取目标的分数值

        Args:
            target: st.storable (X) 一个可存储资源的游戏对象
            percent: bool (X) 是否返回百分比

        Returns:
            int | float 如果percent为True，返回百分比float，否则返回具体分数值int

        """
        pass

    @staticmethod
    def health(target: st.hitable, percent: bool = False) -> int | float:
        """
        获取目标的生命值

        Args:
            target: st.hitable (X) 一个可被攻击的游戏对象
            percent: bool (X) 是否返回百分比

        Returns:
            int | float 如果percent为True，返回百分比float，否则返回具体生命值int
        """
        pass

    @staticmethod
    def parts(creep: st.creep, broken: bool = True) -> list[str]:
        """
        获取creep的parts信息

        Args:
            creep: st.creep (X) 一个Creep对象
            broken: bool (X) 是否包含完全损坏的部件. False时可以忽略hit = 0的部件

        Returns:
            list[str]  返回一个列表，包含了目标creep的所有部件(字符串形式). 如果获取失败，返回空列表
        """
        pass

    @staticmethod
    def wait(creep: st.creep) -> int:
        """
        获取目标creep需要等待多少tick后才能进行移动

        Args:
            creep: st.creep (X) 一个Creep对象

        Returns:
            int  返回等待的tick数. 如果获取失败，返回-1. 如果目标无法移动，返回0xffff
        """
        pass

    @staticmethod
    def situation() -> SituationResult:
        """
        获取当前战场的creeps情况

        Returns:
            SituationResult
        """
        pass

    # --------------------------------- machine ---------------------------------
    @staticmethod
    def clusters(points: list[st.point], close_dist: int = 3, min_pt: int = 1) -> list[ClusterResult]:
        """
        对坐标点进行聚类

        Args:
            points: list[st.point] (X) 一个坐标点列表
            close_dist: int (X) 最大邻域距离
            min_pt: int (X) 一个聚类的最小点数

        Returns:
            list[list[st.point]]  返回一个二维列表，包含了聚类后的坐标点
        """
        pass

    # --------------------------------- graph ---------------------------------

    @staticmethod
    def direction(vec_obj: st.point, target: st.point = None) -> int:
        """
        传入一个向量，返回对应的方向常量；或者传入两个坐标点，返回对应的方向常量

        Args:
            vec_obj: st.point (X) 一个坐标点或一个向量
            target: st.point (X) 一个坐标点

        Returns:
            int
        """
        pass

    @staticmethod
    def reversedDirection(direction: int) -> int:
        """
        返回一个方向的反向

        Args:
            direction: int (X) 方向常量

        Returns:
            int
        """
        pass

    @staticmethod
    def expandDirection(direction: int) -> list[int]:
        """
        返回一个方向的扩展方向

        Args:
            direction: int (X) 方向常量

        Returns:
            list[int]
        """
        pass

    @staticmethod
    def directionPoint(direction: int, bias: Point = None) -> Point:
        """
        返回一个方向的坐标点, 比如(1, 0)这种,

        Args:
            direction: int (X) 方向常量

        Returns:
            st.point
        """
        pass

    @staticmethod
    def pooling(arr2d, kernel_size=2) -> list[list[int]]:
        """
        Pooling the arr with kernel_size and stride with 'mean'

        Args:
            arr2d: list[list[int]]
            kernel_size: int, strides will equal to kernel_size

        Returns:
            池化后的数组
        """
        pass

    @staticmethod
    def costArray2D(start: st.point = Point(0, 0), end: st.point = Point(100, 100)) -> list[list[int]]:
        """
        返回整个地图的对应roi区域的拷贝

        Args:
            start: st.point (X) 起始坐标, 默认为Point(0, 0)
            end: st.point (X) 结束坐标, 默认为Point(100, 100)

        Returns:
            list[list[int]]
        """
        pass

    @staticmethod
    def shape(arr: list[list[int]]) -> Point:
        """
        获取二维数组的形状

        Args:
            arr: list[list[int]] (X) 一个二维数组

        Returns:
            st.point 返回一个坐标点，包含了二维数组的形状
        """
        pass

    @staticmethod
    def slice2d(arr: list[list[int]], start: st.point = Point(0, 0), end: st.point = None) -> list[list[int]]:
        """
        对二维数组进行切片

        Args:
            arr: list[list[int]] (X) 一个二维数组
            start: st.point (X) 起始坐标
            end: st.point (X) 结束坐标

        Returns:
            list[list[int]] 返回一个二维数组
        """
        pass

    @staticmethod
    def min2d(arr: list[list[int]]) -> int:
        """
        获取二维数组的最小值

        Args:
            arr: list[list[int]] (X) 一个二维数组

        Returns:
            int 返回一个整数
        """
        pass

    @staticmethod
    def max2d(arr: list[list[int]]) -> int:
        """
        获取二维数组的最大值

        Args:
            arr: list[list[int]] (X) 一个二维数组

        Returns:
            int 返回一个整数
        """
        pass

    @staticmethod
    def sum2d(arr: list[list[int]]) -> int:
        """
        获取二维数组的和

        Args:
            arr: list[list[int]] (X) 一个二维数组

        Returns:
            int 返回一个整数
        """
        pass

    @staticmethod
    def mean2d(arr: list[list[int]]) -> int:
        """
        获取二维数组的均值

        Args:
            arr: list[list[int]] (X) 一个二维数组

        Returns:
            int 返回一个整数
        """
        pass

    @staticmethod
    def poolingPrefab(psize: int) -> list[list[int]]:
        """
        读取预设的池化地图

        Args:
            psize: int 池化尺寸, 支持1, 2, 4, 5, 8, 10

        Returns:
            list[list[int]] 返回一个二维数组
        """
        pass

    @staticmethod
    def space2x(psize: int, x: int, y: int, rot: int = 0) -> Point:
        """
        Find a 2x psize square space with the base point x, y

        Args:
            psize: int, the size of the pool. (1, 2, 4, 5, 8, 10)对应搜寻的space大小为(2x2, 4x4, 8x8, 10x10, 16x16, 20x20)
            x: int, the x position of the 100x100 space
            y: int, the y position of the 100x100 space
            rot: 0/1, 表示螺旋的方向, 0代表左逆时针, 1代表右逆时针

        Returns:
            the lt position of the 2x2 space
        """
        pass

    class FindNarrowResult:
        length: int = 0
        points: list[Point] = []
        distance: int = 0

    @staticmethod
    def findNarrow(arr_2d, p0, p1, direct, length=-1, end=255) -> FindNarrowResult:
        """
        在二维数组中从 (p0, p1) 向 direct 方向寻找最窄的区域

        Args:
        arr_2d (list): 二维数组
        p0 (dict): 点对象，包含 'x' 和 'y' 属性
        p1 (dict): 点对象，包含 'x' 和 'y' 属性
        direct (int): 方向，仅支持 4 个轴方向
        length (int, optional): 长度，默认为 -1
        end (int, optional): 结束值，默认为 255

        Returns:
        object: 包含以下属性
            'length' (int): 最窄区域的长度
            'points' (list): 最窄区域的点集
            'distance' (int): 最窄区域的位置
        """
        pass

    @staticmethod
    def boundingRect(pts) -> Rect:
        """
        计算点集的边界矩形

        参数：
        pts (list): 点对象列表，每个点对象包含 'x' 和 'y' 属性

        返回值：
        Rect: 边界矩形对象，包含以下属性
        """
        pass

    @staticmethod
    def expandMapBlock(arr_2d):
        """
        对二维数组进行膨胀操作

        参数：
        arr_2d (list): 二维数组

        返回值：
        list: 膨胀后的二维数组
        """
        pass

    @staticmethod
    def chebRotate45x(point:st.point, old_direction:int, new_direction:int) -> Point:
        """
        计算点在旋转后的新坐标

        Args:
            point: st.point (X) 一个坐标点
            old_direction: int (X) 旧方向 例如TOP
            new_direction: int (X) 新方向  例如LEFT

        Returns:
            st.point (X) 一个坐标点
        """
        pass